/*

  PCB01.POV

  Jaime Vives Piqueres, (?)1997

*/

#version 3.0
#include "colors.inc"
#include "textures.inc"
#include "woods.inc"
#include "metals.inc"
#include "skies.inc"

#declare trazar_pcb=1
#declare trazar_destor=1
#declare trazar_torn=0
#declare trazar_disk=1
#declare trazar_mesa=1
#declare trazar_hab=1
#declare trazar_caja=1
#declare trazar_blur=0

#declare r1=seed(7)

#declare ancho_placa=9.8

#if (trazar_pcb=1)
#include "cmpnnt.inc"
// **** placa pcb ****
union{
 object{placa_base}
 object{c24
  rotate -90*x
  translate -grosor_placa*z
 }
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate radio_c24*4*y
 }
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate -radio_c24*6*y
 }
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate -radio_c24*10*y
 }
 // izqda
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate -(ancho_chip*4.8+ancho_pata_chip*2)*x
  translate radio_c24*3*y
 }
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate -(ancho_chip*6.2+ancho_pata_chip*2)*x
  translate radio_c24*3*y
 }
 object{c24
  rotate -90*x
  translate -grosor_placa*z
  translate -(ancho_chip*5.5+ancho_pata_chip*2)*x
  translate radio_c24*3*y
 }
 object{chip_gordo
  rotate 90*z
  translate (-grosor_placa-alto_chip)*z
  translate (ancho_pata_chip+ancho_chip*2)*x
  translate (alto_chip/2)*y
 }
 object{chip_gordoB
  rotate 90*z
  translate (-grosor_placa-alto_chip)*z
  translate -(ancho_pata_chip*2+ancho_chip*2)*x
  translate (alto_chip/2)*y
 }
 object{chip_gordoC
  rotate 90*z
  translate (-grosor_placa-alto_chip)*z
  translate (ancho_pata_chip+ancho_chip*2)*x
  translate ((alto_chip*1.5)-ancho_chip*2)*y
 }
 object{chip_gordo
  rotate 90*z
  translate (-grosor_placa-alto_chip)*z
  translate -(ancho_pata_chip*2+ancho_chip*2)*x
  translate ((alto_chip*1.5)-ancho_chip*2)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip-ancho_pata_chip*2)*x
  translate ((alto_chip*2)+ancho_chip*1.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate (ancho_chip+ancho_pata_chip*4)*x
  translate ((alto_chip*2)+ancho_chip*1.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip-ancho_pata_chip*2)*x
  translate ((alto_chip*2)+ancho_chip*2.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate (ancho_chip+ancho_pata_chip*4)*x
  translate ((alto_chip*2)+ancho_chip*2.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip*3)*x
  translate ((alto_chip*2)+ancho_chip*1.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip*3)*x
  translate ((alto_chip*2)+ancho_chip*2.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip*5+ancho_pata_chip*2)*x
  translate ((alto_chip*2)+ancho_chip*1.5)*y
 }
 object{chip_med
  rotate 90*z
  translate (-grosor_placa/2-alto_chip)*z
  translate -(ancho_chip*5+ancho_pata_chip*2)*x
  translate ((alto_chip*2)+ancho_chip*2.5)*y
 }
 object{chip_cortog
  rotate 90*z
  translate (-grosor_placa-alto_chip)*z
  translate -(ancho_chip*5.5+ancho_pata_chip)*x
  translate (-ancho_chip+ancho_pata_chip*2)*y
 }
 object{chip_fl1
  rotate 90*z
  translate (grosor_placa-alto_chip)*z
  translate (ancho_chip*2.2+ancho_pata_chip*2)*x
  translate -(ancho_chip*3)*y
 }
 object{chip_fc
  rotate 90*z
  translate (grosor_placa-alto_chip)*z
  translate -(ancho_chip*1.2+ancho_pata_chip*2)*x
  translate -(ancho_chip*3)*y
 }
 object{chapa
  translate <(largo_placa/2+grosor_placa),-0.8,0>
 }
 // conector tape
 #declare num_j=28
 #declare cnt=1
 #while (cnt<=num_j)
   object{jumper_a
    translate <(79/20)+grosor_base_j*cnt,(84/20),-grosor_placa/2>
   }
  #declare cnt=cnt+1
 #end
 // jumpers de verdad
 #declare num_j=16
 #declare cnt=1
 #while (cnt<=num_j)
  #if (rand(r1)>0.3)
   object{jumper_a
    translate <(-137/20)+grosor_base_j*cnt,(-79/20),-grosor_placa/2>
   }
  #else
   object{jumper_c
    translate <(-137/20)+grosor_base_j*cnt,(-79/20),-grosor_placa/2>
   }
  #end
  #declare cnt=cnt+1
 #end
 // sueltos
 object{jumper_a
  rotate 90*z
  translate <(68/20),(80/20),-grosor_placa/2>
 }
 object{jumper_a
  rotate 90*z
  translate <(68/20),(66/20),-grosor_placa/2>
 }
 // dip
 object{conmutador_dip
  rotate 90*z
  translate <(130/20)-ancho_dip/1.8,0,-grosor_placa/2-alto_dip/2>
 }
 // resistencias
 object{ resist01
  translate <(115/20),(-49/20),-grosor_placa/2-0.25>
 }
 object{ resist02
  translate <(115/20),(-40/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  rotate 90*z
  translate <(113/20),(50/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  translate <(-167/20),(31/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  translate <(-188/20),(2/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  translate <(-188/20),(-40/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  translate <(-188/20),(-49/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  rotate 90*z
  translate <(-123/20),(-55/20),-grosor_placa/2-0.25>
 }
 object{ resist02
  rotate 90*z
  translate <(-115/20),(-55/20),-grosor_placa/2-0.25>
 }

 object{ resist01
  rotate 90*z
  translate <(153/20),(5/20),-grosor_placa/2-0.25>
 }
 object{ resist02
  rotate 90*z
  translate <(162/20),(5/20),-grosor_placa/2-0.25>
 }
 object{ resist01
  rotate 90*z
  translate <(153/20),(-48/20),-grosor_placa/2-0.25>
 }
 object{ resist02
  rotate 90*z
  translate <(162/20),(-48/20),-grosor_placa/2-0.25>
 }
 object{ resist02
  translate <(158/20),(19/20),-grosor_placa/2-0.25>
 }

 object{ resist03
  translate <(158/20),(46/20),-grosor_placa/2-0.25>
 }
 object{ resist03
  translate <(158/20),(-32/20),-grosor_placa/2-0.25>
 }
 object{ resist03
  translate <0,(-68/20),-grosor_placa/2-0.25>
 }

 object{ resist04
  rotate 90*z
  translate <(68/20),(48/20),-grosor_placa/2-0.25>
 }
 object{ resist04
  rotate 90*z
  translate <(77/20),(48/20),-grosor_placa/2-0.25>
 }
 object{ resist04
  translate <(159/20),(39/20),-grosor_placa/2-0.25>
 }
 object{ resist04
  translate <(159/20),(-7/20),-grosor_placa/2-0.25>
 }
 object{ resist04
  rotate 90*z
  translate <(-146/20),(-80/20),-grosor_placa/2-0.25>
 }
 object{ R72pr10k
  translate <(-184/20),(77/20),-grosor_placa/2-alto_72/2>
 }
 // chips pequeos
 object{ chip_peq
  translate <(-188/20),(24/20),-grosor_placa/2-alto_chip/2>
 }
 object{ chip_peq
  translate <(95/20),(51/20),-grosor_placa/2-alto_chip/2>
 }
 // reloj
 object{reloj_tco
  translate <(140/20),(-74/20),-grosor_placa/2-alto_tco/2>
 }
 // cond.plamo
 object{con_plan
  scale 1.5
  translate <(144/20)+largo_tco/2+1.1,(-77/20),-grosor_placa/2-alto_tco/2>
 }
 object{con_plan
  scale 1.3
  translate <(-189/20),(-13/20),-grosor_placa/2-alto_tco/2>
 }
 object{con_plan
  scale 1.3
  translate <(-190/20),(-28/20),-grosor_placa/2-alto_tco/2>
 }
 object{con_plan
  scale 1.4
  translate <(-139/20),(-58/20),-grosor_placa/2-alto_tco/2>
 }
 // condensadores cilindricos
 object{ con_cil
  translate <(139/20),(40/20),-grosor_placa/2-alto_cc/2>
 }
 // p1 c.variable
 // tp3 c.variable
 rotate 85*x
 rotate 2*z
 rotate -60*y
 translate -(dist_slot/3)*x
 translate -4*y
 translate 6*z
}
#end // if pcb

#if (trazar_mesa=1)
#declare madera16 =
    texture {  pigment{ P_WoodGrain15A color_map { M_Wood15A }
                     warp{black_hole <0,0,0>,0.2
                          falloff 2
                          strength 2
                          repeat <.4,0,.4>
                          turbulence<.05,0,.1>
                          inverse}
    }}
    texture {  pigment{ P_WoodGrain15B color_map { M_Wood15B }
                     warp{black_hole <0,0,0>,0.2
                          falloff 2
                          strength 2
                          repeat <.4,0,.4>
                          turbulence<.05,0,.1>
                          inverse}
    }}

#declare T_Mesa=
 texture{
  madera16
  rotate (1+1*rand(r1))*x
  scale (4+4*rand(r1))
  translate (50*rand(r1))*x
  finish{F_MetalA}
 }

#declare cnt=-30
//#declare mesa =
union{
  #while (cnt<=30)
    box{<cnt,-1,-20>,<cnt+3.999,0,30>
      texture{T_Mesa
        translate <cnt,cnt,cnt>
      }
    }
    #declare cnt=cnt+4
  #end
  translate -(ancho_placa/2)*y
}
#end // mesa

#if (trazar_hab=1)
// **** habitacion ****
box{
 <-200,-75,-200>
 <200,100,35>
 pigment{Thistle}
 normal{granite scale 4*y}
}
#end // if habit

#if (trazar_destor=1)
#declare tx_mango =texture{
Orange_Glass finish{caustics 2}}
#declare tx_metal =texture{Aluminum scale 0.1}
#include "destor.inc"
object{
 destornillador
 translate -8*y
 rotate y*15
 rotate z*90
 rotate 30*y
 translate <-9,-4,-8>
}
#end // destor

#if (trazar_torn=1)
#declare metal_torn=
 texture{Chrome_Texture}
#declare tornillo_pc =
union{
 // *** tuerca ***
 difference{
  intersection{
   cylinder{<0,0,0>,<0,1,0>,1.9}
   plane{x,0 rotate 180*z translate -1.6}
   plane{x,0 translate 1.6}
   plane{z,0 translate 1.6 rotate 30*y}
   plane{z,0 translate 1.6 rotate -30*y}
   plane{z,0 rotate 180*x translate -1.6 rotate 30*y}
   plane{z,0 rotate 180*x translate -1.6 rotate -30*y}
  }
  cylinder{<0,0.8,0>,<0,1.1,0>,1.5}
  box{<-1.3,0.2,-0.3>,<1.3,0.9,0.3>}
  box{<-0.3,0.2,-1.3>,<0.3,0.9,1.3>}
  cone{<0,0.9,0>,0.3,<0,0.1,0>,0.05}
 texture{metal_torn}
 }
 // *** disco ***
 cylinder{<0,0,0>,<0,0.1,0>,1.9
  texture{metal_torn}
 }
 // *** rosca ***
 cone{<0,0,0>,0.8,<0,-2.5,0>,0.6
  texture{metal_torn}
  normal{
   bump_map{gif "rosca.gif" map_type 2 bump_size 4 }
   translate <-0.5,-0.5,0>
   scale 4
   rotate 40*z
  }
 }
 // *** punta ***
 cone{<0,-2.5,0>,0.6,<0,-2.8,0>,0.2
  texture{metal_torn}
 }
 scale 0.2
}

union{
object{
 tornillo_pc
 rotate <10,30,-58>
 translate <-1,0,3>
}
object{
 tornillo_pc
 rotate <10,30,-58>
 rotate 50*y
 translate <1,0,1>
}
object{
 tornillo_pc
 rotate <10,30,-58>
 rotate -30*y
 translate <-1.4,0,4>
}
object{
 tornillo_pc
 rotate <10,30,-58>
 rotate 100*y
 translate <0.6,0,3>
}
translate <0,-4.6,-10>
}
#end // tornillos

#if (trazar_disk=1)
#include "diskt.inc"
union{
 object{diskette}
 object{diskette translate .30*1*y rotate 15*rand(r1)*y}
 object{diskette translate .30*2*y rotate 15*rand(r1)*y}
 object{diskette translate .30*3*y rotate 15*rand(r1)*y}
 object{diskette translate .30*4*y rotate 15*rand(r1)*y}
 object{diskette translate .30*5*y rotate 15*rand(r1)*y}
 rotate -50*y
 translate <9,-3.95,-6>
}
#end // diskette

#if (trazar_caja=1)
#declare caja=
box{
 <-15,-12,-2.5>
 < 15, 12, 2.5>
 texture{
  pigment{
   image_map{
    tga "caja01.tga"
   }
   translate <-.5,-.5,0>
  }
  scale <30,24,5>
 }
}
object{caja
// rotate 90*x
 rotate -25*y
// translate <-17,6.5,20>
 translate <0,6.5,20> // camara 3
}
#end // if caja

// ++++ camara 1 ++++
#declare desde=<6,20,-46>
#declare hacia=<2,0,-4>
#declare zoom=2*z
// ++++ camara 2 ++++
//#declare desde=<6,2,-28>
//#declare hacia=<0,0,0>
//#declare zoom=1.7*z
// ++++ camara 3 ++++
//#declare desde=<-5,-3,-4>
//#declare hacia=<-3,-4.2,1>
//#declare zoom=1.5*z

camera{
 location desde
 direction zoom
 look_at hacia
 #if (trazar_blur=1)
  blur_samples 128
  aperture 0.2
  focal_point hacia
  confidence 0.9
  variance 1/128
 #end
// rotate 30*y
}

sphere{hacia,0.1 pigment{Red}}

// ++++ luz de camara ++++
light_source{
 desde
 color Gray/3
 fade_distance 100
 fade_power 2
 shadowless
}

// ++++ foco ++++
light_source{
 <-100,70,10>
 color Silver/2+Gold/2+Gray/2
 spotlight
 point_at <0,0,0>
 tightness 0
 radius 4
 falloff 8
 fade_distance (70+100+20)*1.5
 fade_power 2
}

